Common subdirectories: /Volumes/PLT Scheme v372/PLT Scheme v372/collects/frtime/compiled and ./compiled
Common subdirectories: /Volumes/PLT Scheme v372/PLT Scheme v372/collects/frtime/demos and ./demos
diff -U 5 /Volumes/PLT Scheme v372/PLT Scheme v372/collects/frtime/frp-core.ss ./frp-core.ss
--- /Volumes/PLT Scheme v372/PLT Scheme v372/collects/frtime/frp-core.ss	2007-12-27 06:11:10.000000000 -0500
+++ ./frp-core.ss	2008-03-22 13:09:00.000000000 -0400
@@ -732,24 +732,32 @@
       [_ (void)]))
   
   (define (signal-count)
     (! man `(stat ,(self)))
     (receive [n n]))
-
-  (define exn-handler (lambda (exn) (raise exn)))
   
+  (define (hash-table-size ht)
+    (let ([x 0])
+      (hash-table-for-each ht (lambda (k v) 
+                                (if k (set! x (add1 x)))))
+      x))
+  
+  (define exn-handler (lambda (exn) (raise exn)))
+
   ;;;;;;;;;;;;;
   ;; Manager ;;
   ;;;;;;;;;;;;;
   
   ;; the manager of all signals
   (define man
     (spawn/name
      'frtime-heart
      (let* ([named-providers (make-hash-table)] 
             [cur-beh #f]
+            [logical-time 0]
             [signal-cache (make-hash-table 'weak)]
+            [last-known-signal-count 40]
             [notifications empty]
             
             ;; added for run-thunk/stablized
             [thunks-to-run empty]
             [do-and-queue (lambda (pid thnk)
@@ -816,14 +824,11 @@
                            (set! thunks-to-run (cons (list rtn-pid thunk) thunks-to-run))
                            (loop))]
                         
                         
                         [('stat rtn-pid)
-                         (let ([x 0])
-                           (hash-table-for-each signal-cache (lambda (k v) 
-                                                               (if k (set! x (add1 x)))))
-                           (! rtn-pid x))]
+                         (! rtn-pid (hash-table-size signal-cache))]
                         
                         [('bind sym evt)
                          (let ([forwarder+listeners (cons #f empty)])
                            (set-car! forwarder+listeners
                                      (event-forwarder sym evt forwarder+listeners))
@@ -879,10 +884,16 @@
              
              (for-each (lambda (lst)
                          (! (first lst) (rest lst)))
                        notifications)
              
+             (set! logical-time (add1 logical-time))
+             (when (and (zero? (modulo logical-time 200))
+                        (> (hash-table-size signal-cache) (* 2 last-known-signal-count)))
+               (collect-garbage)
+               (set! last-known-signal-count (hash-table-size signal-cache)))
+             
              (set! notifications empty)
              (set! thunks-to-run empty)
              
              (inner)))))))
   
diff -U 5 /Volumes/PLT Scheme v372/PLT Scheme v372/collects/frtime/lang-ext.ss ./lang-ext.ss
--- /Volumes/PLT Scheme v372/PLT Scheme v372/collects/frtime/lang-ext.ss	2007-12-26 12:44:01.000000000 -0500
+++ ./lang-ext.ss	2008-03-22 13:12:56.000000000 -0400
@@ -374,20 +374,20 @@
                                (current-inexact-milliseconds))
                          empty)]
              [head last]
              [producer (proc->signal
                         (lambda ()
-                          (let* ([now (current-inexact-milliseconds)]
+                          (let* ([now (and consumer (current-inexact-milliseconds))]
                                  [ms (value-now ms-b)])
                             (let loop ()
                               (if (or (empty? (rest head))
                                       (< now (+ ms (cdadr head))))
                                   (caar head)
                                   (begin
                                     (set! head (rest head))
                                     (loop)))))))]
-             [consumer (proc->signal/dont-gc-unless producer
+             [consumer (proc->signal
                         (lambda ()
                           (let* ([now (current-inexact-milliseconds)]
                                  [new (deep-value-now beh)]
                                  [ms (value-now ms-b)])
                             (when (not (equal? new (caar last)))
@@ -408,12 +408,12 @@
     (opt-lambda (b [ms-b 20])
       (letrec ([accum 0]
                [last-time (current-inexact-milliseconds)]
                [last-val (value-now b)]
                [last-alarm 0]
-               [producer (proc->signal (lambda () accum))]
-               [consumer (proc->signal/dont-gc-unless producer void b ms-b)])
+               [producer (proc->signal (lambda () (and producer accum)))]
+               [consumer (proc->signal void b ms-b)])
         (set-signal-thunk!
          consumer
          (lambda ()
            (let ([now (current-inexact-milliseconds)])
              (if (> now (+ last-time 20))
Common subdirectories: /Volumes/PLT Scheme v372/PLT Scheme v372/collects/frtime/private and ./private